//---------------------------------
// 2019/9/16

#ifndef ARDUCAM_MANAGER_H
#define ARDUCAM_MANAGER_H

#include "Arduino.h"
#include "Storage.h"
#include <Wire.h>
#include <SPI.h>
#include <ArduCAM.h>


class ArduCamManager{
private:  
  ArduCAM*arduCam;
  uint8_t pinSDCS;        // SD SPI CS Pin
  uint8_t spiClkSD = 8;   // SD SPI clock MHz
  uint8_t pinArduCamCS;   // ArduCAM CS Pin
  uint8_t jpegSize;
  uint8_t jpegQuality;
  
  
public:
  static const uint16_t bufferSize = 256; // Picture transfer buffer size

  static const uint8_t testData = 0x55;  // SPI test data on test register
  static const uint8_t initData = 0xA5;  // SPI init data on test register

  // Return code of check() function
  static const uint8_t statusReady = 0;
  static const uint8_t statusNotInit = 1;
  static const uint8_t statusNotConnected = 2;
  
  static const uint8_t qualityLow = 0xC;
  static const uint8_t qualityFair = 0x8;
  static const uint8_t qualityGood = 0x4;


  String storeDir = "/"; // Directory to store photo
    
  ArduCamManager(uint8_t cameraCS, uint8_t SDCS, uint8_t size, uint8_t quality);
  ~ArduCamManager();
  uint8_t check();
  void init();
  void setJpegParam(uint8_t size, uint8_t quality);
  uint8_t getJpegSize();
  uint8_t getJpegQuality();
  bool takePhoto(String file);
  
};

#endif
