//---------------------------------
// 2017/1/27


#include "Storage.h"


const String Storage::opLogFileName = "op.log";
  
void Storage::opLog(String logStr){
  if(opLogSerial){
    Serial.print(logStr);
  }

  if(!opLogStorage){
    return;
  }
  
  String path = String("/") + opLogFileName;
  // Log on SPIFFS
  #ifdef STORAGE_SPIFFS
  if(SPIFFS.begin()){
    File file = SPIFFS.open(path, "a");
    if(file){
      file.print(logStr.c_str());
      file.close();
    }
    SPIFFS.end();
  }
  // Log on SD
  #else
  SdFat*SD = new SdFat;
  if(SD->begin(pinSDCS, SD_SCK_MHZ(spiClkSD))){    
    File file = SD->open(path, FILE_WRITE);
    if(file){
      file.write(logStr.c_str());
      file.close();
    }
  }
  delete SD;
  #endif
}


