//---------------------------------
// 2018/1/18

#ifndef TSL2561I2C_H
#define TSL2561I2C_H

#include "Arduino.h"

class TSL2561I2C{
private:
  // I2C Pin
  uint8_t pinSCL;
  uint8_t pinSDA;

public:
  static const uint8_t i2cAddr = 0x39;

  // ADC Gain
  static const uint8_t againLow = 0;
  static const uint8_t againHigh = 1;

  // ADC Integration time
  static const uint8_t atime13ms = 0;
  static const uint8_t atime101ms = 1;
  static const uint8_t atime402ms = 2;


  // Measurement result
  uint16_t ch0 = 0;
  uint16_t ch1 = 0;
  float lux = 0;
  uint8_t again = againHigh;
  uint8_t atime = atime402ms;


  TSL2561I2C(uint8_t sda, uint8_t scl);
  uint8_t readAddress(uint8_t addr);
  void readAddress(uint8_t addr, uint8_t*data, uint8_t length);
  void writeAddress(uint8_t addr, uint8_t data);
  void clearInt();
  bool idRead();
  void timing(uint8_t again, uint8_t atime);
  void alsIntegration();
  bool meas();
  void calcLux();
  void setInterrupt(bool enable, uint16_t lowTh, uint16_t highTh, uint8_t persist);
  String getLuxStr();
};

#endif

